package org.deephacks.tools4j.config.internal.core;

import javax.enterprise.event.Observes;
import javax.enterprise.inject.spi.AfterBeanDiscovery;
import javax.enterprise.inject.spi.BeanManager;
import javax.enterprise.inject.spi.Extension;
import javax.enterprise.inject.spi.ProcessAnnotatedType;

import org.deephacks.tools4j.config.Config;
import org.deephacks.tools4j.config.RuntimeContext;
import org.deephacks.tools4j.config.model.Lookup;

public class ConfigCdiExtension implements Extension {
	private static final RuntimeContext ctx = Lookup.get().lookup(
			RuntimeContext.class);

	public void afterBeanDiscovery(@Observes AfterBeanDiscovery event,
			BeanManager manager) {
		event.addContext(new ConfigCdiContext());
	}

	<X> void processAnnotatedType(@Observes ProcessAnnotatedType<X> pat) {
		if (!pat.getAnnotatedType().isAnnotationPresent(Config.class)) {
			return;
		}
		ctx.register(pat.getAnnotatedType().getJavaClass());
	}
}
